!config
# Arara, the cool TeX automation tool
# Copyright (c) 2020, Island of TeX
# All rights reserved.
#
# This rule is part of arara-rules-ko.
# 2021/04. for arara 6.0 (TeX Live 2021)
# this rule is based on arara-rules-makeindex.yaml 
identifier: komkindex
name: koMakeIndex
authors:
- Karnes Kim
commands:
- name: The MakeIndex for koTeX
  command: >
    @{
        base = getBasename(reference);
        infile = base.concat('.').concat(input[0]);
        outfile = [ '-o', base.concat('.').concat(output[0]) ];
        logfile = [ '-t', base.concat('.').concat(log[0]) ];
        return getCommand(script, koreanfirst, style, order, options,
                          logfile, outfile, infile);
    }
arguments:
- identifier: script
  flag: >
    @{
    	parameters.script
    }
  default: komkindex
- identifier: input
  flag: >
    @{
      parameters.input
    }
  default: idx
- identifier: output
  flag: >
    @{
      parameters.output
    }
  default: ind
- identifier: log
  flag: >
    @{
      parameters.log
    }
  default: ilg
- identifier: koreanfirst
  flag: >
    @{
        isTrue(parameters.koreanfirst, '-k')
    }
- identifier: order
  flag: >
    @{
        if ([ 'letter', 'word' ].contains(parameters.order)) {
            return isTrue(parameters.order == 'letter', '-l', '');
        }
        else {
            throwError('The provided order is invalid.');
        }
    }
- identifier: style
  flag: "@{ [ '-s', parameters.style ] }"
- identifier: options
  flag: >
    @{
        if (isList(parameters.options)) {
            return parameters.options;
        }
        else {
            throwError('I was expecting a list of options.');
        }
    }
